package rootgui.controller;

import rootgui.model.SimulationRun;
import rootgui.model.objects.SimulationModel;

/*
 * Interface concerning simulation control operations
 */
public interface ISimulationControl {

	// public void reset();

	/*
	 * Perform one iteration
	 */
	public void step();

	// public void stepAll();

	public void cancel();

	/*
	 * Specifies the tissue file name
	 */
	public void setTissueFileName(String fileName);

	/*
	 * Initialises the tissue
	 */
	public boolean initTissue();

	/*
	 * Sets a model parameter
	 */
	public void setModelParameter(String modelName, String parameter,
			String value);

	/*
	 * Adds a SimulationModel to the simulation
	 */
	public void loadSimulationModel(SimulationModel sm);

	/*
	 * Specifies the maximum number of snapshots (images) the simulation should
	 * output
	 */
	public void setMaxIterations(int iterations);
	
	public void setTimestep(double timestep);

	/*
	 * Returns true if there is an active connection to the simulation server
	 */
	public boolean isConnected();

	/*
	 * Disconnects the simulation server
	 */
	public void disconnectSimulation();
	
	public void setSimulationRun(SimulationRun simRun);
}
