package rootgui.model;

import java.io.Serializable;
import java.util.Map;

import visualiser.Figure;

/*
 * to record current SimulationRun, configuration of the settings panel and Figure in current selected tab
 */
public class SimulationRecord implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2166976782150067557L;

	private SimulationRun simulationRun;

	private Map<String, Serializable> configuration;

	private Figure figure;

	public SimulationRecord(SimulationRun simRun,
			Map<String, Serializable> configuration, Figure figure) {
		this.simulationRun = simRun;
		this.configuration = configuration;
		this.figure = figure;
	}

	public SimulationRun getSimulationRun() {
		return simulationRun;
	}

	public Map<String, Serializable> getConfiguration() {
		return configuration;
	}

	public Figure getFigure() {
		return figure;
	}

}
