package rootgui.model.exceptions;

import rootgui.model.objects.Cell;
import rootgui.model.objects.Wall;

public class ImproperlyStructuredCellWallsException extends RuntimeException {

	public ImproperlyStructuredCellWallsException() {
	}

	public ImproperlyStructuredCellWallsException(String msg) {
		super(msg);
	}

	public ImproperlyStructuredCellWallsException(Cell cell, String msg) {

		super(explainMsg(cell, msg));
	}

	private static String explainMsg(Cell cell, String msg) {
		StringBuilder sb = new StringBuilder();
		sb.append(String.format("cell id=<%d>; ", cell.getId()));
		sb.append("{");
		for (Wall w : cell.getWalls()) {
			sb.append(String.format("[%s,..,%s],", w.getHead(), w.getTail()));
		}
		sb.deleteCharAt(sb.length() - 1);
		sb.append("}; ");
		sb.append(msg);
		return sb.toString();
	}
}
