package rootgui.view;

public class SystemOutputAdapter implements IConsoleOutput
{

	private int level = ANY;

	@Override
	public void printStd(final int srIndex, String message)
	{
		System.out.print(message);
	}

	@Override
	public void printErr(final int srIndex, String message)
	{
		System.err.print(message);
	}

	@Override
	public void printException(final int srIndex, Exception e)
	{
		System.err.print(e);
	}

	@Override
	public void printlnStd(final int srIndex, String message)
	{
		System.out.println(message);
	}

	@Override
	public void setOutputLevel(int level)
	{
		this.level = level;
	}

	@Override
	public int getOutputLevel()
	{
		return level;
	}

	@Override
	public void printStd(final int srIndex, String message, int messageLevel)
	{
		if (level <= messageLevel)
			System.out.print(message);
	}
	
	@Override
	public void printlnStd(final int srIndex, String message, int messageLevel)
	{
		if(level<= messageLevel)
			System.out.println(message);
	}

	@Override
	public void printErr(final int srIndex, String message, int messageLevel) {
		// TODO Auto-generated method stub
		
	}
}
