package visualiser.viewpanel.view.cellrendering;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.Stroke;
import java.awt.geom.Path2D;
import java.util.Collection;
import java.util.List;

import rootgui.model.objects.Cell;
import rootgui.model.objects.Wall;

import visualiser.viewpanel.view.CellView;

public class AUX1CellRenderer extends AbsCellRenderer {

	@Override
	public void drawCells(Collection<CellView> cvs, Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
				RenderingHints.VALUE_ANTIALIAS_ON);
		
		int errCount = 0;
		int trueCount = 0;
		int falseCount = 0;
		// saving the state
		Color c = g2.getColor();
		Stroke s = g2.getStroke();

		for (CellView cv : cvs) {
			Path2D[] auxs = cv.getFrame();
			try {
				Integer cellID = cv.getCellID(); // get species value
				Cell cell = sr.getRecord().getGeometry().getCellById(cellID);
				List<Wall> walls = cell.getWalls();

				for (int i = 0; i < walls.size(); i++) {
					Wall w = walls.get(i);
					String id = "(" + cellID + "_" + w.getId() + ")";
					double value = 0;
					try {
						value = sr.get(id);
//						if (value==0)
//							System.out.println((falseCount) + " AUX1CEllRenderer: wall id " + id + " = " + sr.get(id) + " is false!");
//							falseCount++;
					} catch (Exception e) {
						// TODO Auto-generated catch block
//						 e.printStackTrace();
//						System.err.println((errCount) + " AUX1CEllRenderer: drawCells error; id " + id + " not found!");
						errCount++;
					}
					if (value >0) {
						Color surfaceColour = Color.MAGENTA;
						if(value==1){
						surfaceColour = Color.GREEN;
						}
						
//						System.out.println((trueCount++) + " AUX1CEllRenderer: wall id " + id + " true!");
						// drawing
						g2.setColor(surfaceColour);
						g2.setStroke(CellView.thinStroke);
						g2.draw(auxs[i]);

					}
				}
				// sr.get(id)
				// cv.setSaturation(minRange, maxRange, v);
			} catch (Exception e) {
				// e.printStackTrace();
			}
		}
//		System.out.println((falseCount) + " AUX1CEllRenderer: walls false!");
//		System.err.println("AUX1CEllRenderer: " + errCount + " walls not found!");
		// restoring the state
		g2.setColor(c);
		g2.setStroke(s);
	}

}
