package visualiser.viewpanel.view.cellrendering;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.Stroke;
import java.awt.geom.Path2D;
import java.util.Collection;
import java.util.List;

import rootgui.model.objects.Cell;
import rootgui.model.objects.Wall;
import visualiser.viewpanel.view.CellView;

public class PINCellRenderer extends AbsCellRenderer {

	@Override
	public void drawCells(Collection<CellView> cvs, Graphics g) {
		// the SpeciesRecords will be loaded with keys respecting the following
		// format: (xx_yy), where xx is the cell id and yy is the wall id
		Graphics2D g2 = (Graphics2D) g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
				RenderingHints.VALUE_ANTIALIAS_ON);

		// saving the state
		Color c = g2.getColor();
		Stroke s = g2.getStroke();

		for (CellView cv : cvs) {
			// drawing
			Path2D[] pins = cv.getFrame();
			try {
				Integer cellID = cv.getCellID(); // get species value
				Cell cell = sr.getRecord().getGeometry().getCellById(cellID);
				List<Wall> walls = cell.getWalls();

				for (int i = 0; i < walls.size(); i++) {
					Wall w = walls.get(i);
					String id = "(" + cellID + "_" + w.getId() + ")";
					boolean v = false;
					try {
						v = sr.get(id) > 0.5 ? true : false;
					} catch (Exception e) {
						// e.printStackTrace();
					}
					if (v) {
						Color surfaceColour = Color.red;

						// drawing
						g2.setColor(surfaceColour);
						g2.setStroke(CellView.thinStroke);
						g2.draw(pins[i]);
					}
				}
			} catch (Exception e) {
				// e.printStackTrace();
			}
		}
		// restoring the state
		g2.setColor(c);
		g2.setStroke(s);
	}

}
