package visualiser.viewpanel.view.tabs;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Arrays;

import javax.swing.JTabbedPane;
import javax.swing.SwingUtilities;

import rootgui.model.objects.Species;
import rootgui.view.SpeciesSelectionDialog;

import visualiser.Figure;
import visualiser.Visualiser;

public class MouseListenerWrapper implements MouseListener {

    private MouseListener delegate;
    private Visualiser vis;

    public MouseListenerWrapper(MouseListener delegate, Visualiser vis) {
        this.delegate = delegate;
        this.vis = vis;
    }

	@Override
	public void mouseClicked(MouseEvent e) {	

		delegate.mouseClicked(e);
	}

	@Override
	public void mousePressed(MouseEvent e) {
		if (SwingUtilities.isRightMouseButton(e)) {
			Species [] loadedSpecies=vis.getTabHistDataProvider().getLoadedSpeciesArray(vis.getSelectedSimID());
			
			SpeciesSelectionDialog.showDialog(vis.getRenderPanel(), null, "Species: ",
					"Select species",  loadedSpecies);
			if (SpeciesSelectionDialog.getButtonAction() == SpeciesSelectionDialog.OK
					&& SpeciesSelectionDialog.getSpecies().length > 0) {
				Figure f = new Figure(SpeciesSelectionDialog.getSpecies(),
						SpeciesSelectionDialog.getMinRanges(),
						SpeciesSelectionDialog.getMaxRanges(),
						SpeciesSelectionDialog.getSelectedRows());
				f.setNoColumns(SpeciesSelectionDialog.getNoColumns());
				
				vis.setFigureToActiveTab(f);
			}
			return;
		} else if (SwingUtilities.isLeftMouseButton(e)) {
			
		}
		
        delegate.mousePressed(e);
		
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		 delegate.mouseReleased(e);
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		delegate.mouseEntered(e);
		
	}

	@Override
	public void mouseExited(MouseEvent e) {
		 delegate.mouseExited(e);
		
	}

}